﻿/**

*/
module nemuxi.lang;

debug import std.stdio: wl = writefln, pl = printf;
debug(lang) void main() {}

import etc.kareki.kareki;

import nemuxi.file.items.item;
import nemuxi.negui.negui;

final class Language {
	private Kareki kareki;
	this(AkiDocument aki) {
		kareki = aki;
	}
	string opCall() {
		return kareki["p"].defGet("aaa");
	}
}
debug(lang) unittest {
	auto lang=new Language(new AkiDocument(["p\\p"]));
	wl(lang());
}
/+
final class Language {
	invariant() {
		assert(aki);
	}
	private AkiDocument aki;

	this(AkiDocument data)
	in {
		assert(data);
	}
	body {
		aki = data;
	}

	private invariant static struct {
		auto MESSAGE_TREE = "Message";
		auto MESSAGE_OK     = MESSAGE_TREE ~ "/OK";
		auto MESSAGE_CANCEL = MESSAGE_TREE ~ "/Cancel";
		auto MESSAGE_YES    = MESSAGE_TREE ~ "/Yes";
		auto MESSAGE_NO     = MESSAGE_TREE ~ "/No";
	}
	static enum MESSAGE {
		OK,
		CANCEL,
		YES,
		NO
	}
	///
	string message(MESSAGE Message) {
		string Tree, Def;
		with(MESSAGE) switch(Message) {
			case OK:     Tree=MESSAGE_OK;     Def="ok";     break;
			case CANCEL: Tree=MESSAGE_CANCEL; Def="cancel"; break;
			case YES:    Tree=MESSAGE_YES;    Def="yes";    break;
			case NO:     Tree=MESSAGE_NO;     Def="no";     break;
			default: assert(false);
		}
		return aki.defGet(Tree, Def);
	}
	
	private invariant static struct {
		auto SHOW_TREE = "Show";
		auto SHOW_HIDE            = SHOW_TREE ~ "/Hide";
		auto SHOW_SHOWNORMAL      = SHOW_TREE ~ "/Normal";
		auto SHOW_SHOWMINIMIZED   = SHOW_TREE ~ "/Minimized";
		auto SHOW_SHOWMAXIMIZED   = SHOW_TREE ~ "/Maximized";
		auto SHOW_SHOWNOACTIVATE  = SHOW_TREE ~ "/NoActivete";
		auto SHOW_SHOW            = SHOW_TREE ~ "/Show";
		auto SHOW_MINIMIZE        = SHOW_TREE ~ "/Minimize";
		auto SHOW_SHOWMINNOACTIVE = SHOW_TREE ~ "/NoActivete/Minimize";
		auto SHOW_SHOWNA          = SHOW_TREE ~ "/NoActivete/Show";
		auto SHOW_RESTORE         = SHOW_TREE ~ "/Restore";
		auto SHOW_SHOWDEFAULT     = SHOW_TREE ~ "/Default";
		auto SHOW_FORCEMINIMIZE   = SHOW_TREE ~ "/Hang";
	}
	///
	string show(NeGui.SW Show) {
		string Tree, Def;
		with(NeGui.SW) switch(Show) {
			case HIDE           : Tree=SHOW_HIDE           ; Def="非表示";                   break;
			case SHOWNORMAL     : Tree=SHOW_SHOWNORMAL     ; Def="通常表示";                 break;
			case SHOWMINIMIZED  : Tree=SHOW_SHOWMINIMIZED  ; Def="最大化";                   break;
			case SHOWMAXIMIZED  : Tree=SHOW_SHOWMAXIMIZED  ; Def="最小化";                   break;
			case SHOWNOACTIVATE : Tree=SHOW_SHOWNOACTIVATE ; Def="通常表示(非アクティブ)";   break;
			case SHOW           : Tree=SHOW_SHOW           ; Def="表示";                     break;
			case MINIMIZE       : Tree=SHOW_MINIMIZE       ; Def="最小化して次のウィンドウ"; break;
			case SHOWMINNOACTIVE: Tree=SHOW_SHOWMINNOACTIVE; Def="最小化(非アクティブ)";     break;
			case SHOWNA         : Tree=SHOW_SHOWNA         ; Def="表示(非アクティブ)";       break;
			case RESTORE        : Tree=SHOW_RESTORE        ; Def="復元";                     break;
			case SHOWDEFAULT    : Tree=SHOW_SHOWDEFAULT    ; Def="起動時の状態";             break;
			case FORCEMINIMIZE  : Tree=SHOW_FORCEMINIMIZE  ; Def="強制最小化";               break;
			default: assert(false);
		}
		return aki.defGet(Tree, Def);
	}
	
	private invariant static struct {
		auto ITEM_TYPE_TREE   = "Item/Type";
		auto ITEM_TYPE_NORMAL = ITEM_TYPE_TREE ~ "/Normal";
		auto ITEM_TYPE_URI    = ITEM_TYPE_TREE ~ "/URI";
		auto ITEM_TYPE_MULTI  = ITEM_TYPE_TREE ~ "/Multi";
		auto ITEM_TYPE_LINK   = ITEM_TYPE_TREE ~ "/Link";
	}
	string itemType(Item.TYPE Type) {
		string Tree, Def;
		with(Item.TYPE) switch(Type) {
			case NORMAL: Tree=ITEM_TYPE_NORMAL; Def="通常"; break;
			case URI:    Tree=ITEM_TYPE_URI;    Def="URL";  break;
			case MULTI:  Tree=ITEM_TYPE_MULTI;  Def="複数"; break;
			case LINK:   Tree=ITEM_TYPE_LINK;   Def="参照"; break;
			default : assert(false);
		}
		return aki.defGet(Tree, Def);
	}
}
//Independent 
+/


