﻿/**

*/
module nemuxi.system.log;

debug import std.stdio: wl = writefln, pl = printf;
debug(log) void main() {}

import std.file;
import std.string;
import std.conv;
import std.stream;

import nemuxi.system.timer;

static class Logger {
	invariant() {
		if(Flag) assert(fs);
		else     assert(!fs);
	}
	static bool Flag;
	
	static private {
		string path;
		invariant string DIR = `.\Logs\`;
		BufferedFile fs;
	}
	static ~this() {
		if(fs) {
			Logger.write("Log End.", "Nemuxi", 0);
			fs.close();
		}
	}
	/+
	static this() {
		auto date=new DateTime();

		path = format(
			"%s%04s-%02s-%02s(%s)%02s-%02s-%02s.log",
			DIR,
			date.year,
			date.month,
			date.day,
			date.weekName(date.week),
			date.hour,
			date.minute,
			date.second
		);
	}
	+/
	static bool flag() {
		return Flag;
	}
	static void flag(bool Flag) {
		this.Flag = Flag;
		
		if(Flag) {
			auto date=new DateTime();
			date.format = DIR ~ "[YYYY]-[M]-[DD]([W]) [hh]-[mm]-[ss].log";
			path = date.toString();
			if(!exists(DIR)) mkdir(DIR);
			
			fs = new BufferedFile(date.toString(), FileMode.OutNew);
			Logger.write("Log Start.", "Nemuxi", 0);
		} else {
			if(fs) fs.close();
			delete fs;
		}
	}
	
	static void write(T)(lazy T msg, string file=__FILE__, int line=__LINE__) {
		if(!Flag) {
			return;
		} else {
			assert(fs);
		}
		auto date=new DateTime();
		date.format = "[YYYY]/[M]/[D] [h]:[m]:[s].[ms]";

		auto msgs=splitlines(to!(string)(msg));
		
		auto s=format(
			"<%s> %s(%s)%s%s%s",
			date,
			file,
			line,
			repeat("=", 20),
			newline,
			msgs.join(newline)
		);
		//append(path, s);
		fs.writeLine(s ~ newline);
		fs.flush;
	}
}

