﻿/**

*/
module nemuxi.utility.simple.sysinfo;

debug import std.stdio: wl = writefln, pl = printf;
debug(sysinfo) void main() {}

import std.cpuid;
import std.string;

import win32.windows;

import nemuxi.utility.meta.memberproperty;

abstract class SystemInfo {
	private SYSTEM_INFO SysInfo;

	this() {
		GetSystemInfo(&SysInfo);
	}
}

class Memory: SystemInfo {
	private MEMORYSTATUS MemStatus;
	
	this() {
		super();
		MemStatus.dwLength = MemStatus.sizeof;
		GlobalMemoryStatus(&MemStatus);
	}

	size_t pageSize() {
		return SysInfo.dwPageSize;
	}

	mixin(StructGetSet!(ptrdiff_t)("minAddress", q{SysInfo.lpMinimumApplicationAddress}));
	/+
	ptrdiff_t minAddress() {
		return cast(ptrdiff_t)SysInfo.lpMinimumApplicationAddress;
	}
	ptrdiff_t maxAddress() {
		return cast(ptrdiff_t)SysInfo.lpMaximumApplicationAddress;
	}
	+/

	size_t minAllocation() {
		return SysInfo.dwAllocationGranularity;
	}

	size_t ramUsingPercent() {
		return MemStatus.dwMemoryLoad;
	}

	size_t ramTotalSize() {
		return MemStatus.dwTotalPhys;
	}
	size_t ramFreeSize() {
		return MemStatus.dwAvailPhys;
	}
	size_t ramUsingSize() {
		return MemStatus.dwTotalPhys - MemStatus.dwAvailPhys;
	}

	size_t pageTotalSize() {
		return MemStatus.dwTotalPageFile;
	}
	size_t pageFreeSize() {
		return MemStatus.dwAvailPageFile;
	}
	size_t pageUsingSize() {
		return MemStatus.dwTotalPageFile - MemStatus.dwAvailPageFile;
	}

	size_t virtualTotalSize() {
		return MemStatus.dwTotalVirtual;
	}
	size_t virtualDreeSize() {
		return MemStatus.dwAvailVirtual;
	}
	size_t virtuaUsingSize() {
		return MemStatus.dwTotalVirtual - MemStatus.dwAvailVirtual;
	}
}

class CPU: SystemInfo {
	this() {
		super();
	}
	
	bool slow() {
		return GetSystemMetrics(SM_SLOWMACHINE)
			? true
			: false
		;
	}
}

